#include "main.h"

int main(int argc, char *argv[]) {
	unsigned char flg = 0;					//終了フラグ
	int rgb;									//カラー
	unsigned char key_flg = 0x00;			//キーフラグ
	SDL_PixelFormat *fmt;

	SDL_Surface *screen;
	SDL_Event event;
	SDL_Surface *image[IMAGE_MAX];						//画像保管用
	SDL_Rect src;
	int i, j;												//汎用変数
	static int ammo = AMMO_MAX; 						//弾数管理
	static int score = 0; 								//スコア
	static int time; 										//タイム管理
	static int scene = SCENE_TITLE; 					//シーン管理
	static int init = SCENE_TITLE;						//シーン毎の初期化
	static struct MOB_DATA mob[ENEMY_MAX]; 			//敵データ
	static struct EFFECT_DATA effect[EFFECT_MAX]; 	//エフェクト用データ
	static SDL_Rect mouse_pos; 				//カーソルの座標
	static int enemy_timer; 					//敵出現用タイマー
	static int reload_timer; 				//リロード時タイマー
	static int fire_count = 0; 				//弾を撃った回数
	static int hit_count = 0; 				//弾が当たった回数
	static int head_count = 0; 				//頭に当たった回数
	static int body_count = 0; 				//体に当たった回数
	static int foot_count = 0; 				//足に当たった回数
	static int kill_count = 0;				//敵を倒した回数
	int color = 0;							//ヒット時のエフェクト用
	int cursorcolor = 0;						//カーソルの色用
	int numberflg = 0;						//数字表示用フラグ
	int c_score = score;						//スコア計算用
	float hit;									//ヒット率計算用
	struct MOB_DATA change;					//交換用MOB_DATA
	int c_time = time;						//時間計算用


	//SDL初期化
	if (SDL_Init(SDL_INIT_VIDEO) < 0) {
		return -1;
	}


	//イメージ読み込み
	IMAGE_ENEMY = (SDL_Surface *) IMG_Load("image/char.bmp"); //エネミーのグラフィック
	if (IMAGE_ENEMY == NULL) return -1;
	IMAGE_BACK = (SDL_Surface *) IMG_Load("image/back.bmp"); //背景のグラフィック
	if (IMAGE_BACK == NULL) return -1;
	IMAGE_AIM = (SDL_Surface *) IMG_Load("image/aim.bmp"); //カーソルのグラフィック
	if (IMAGE_AIM == NULL) return -1;
	IMAGE_HIT = (SDL_Surface *) IMG_Load("image/hit.bmp"); //ヒット箇所のグラフィック
	if (IMAGE_HIT == NULL) return -1;
	IMAGE_MARK_G = (SDL_Surface *) IMG_Load("image/mark_green.bmp"); //頭ヒット時のグラフィック
	if (IMAGE_MARK_G == NULL) return -1;
	IMAGE_MARK_Y = (SDL_Surface *) IMG_Load("image/mark_yellow.bmp"); //胴ヒット時のグラフィック
	if (IMAGE_MARK_Y == NULL) return -1;
	IMAGE_MARK_R = (SDL_Surface *) IMG_Load("image/mark_red.bmp"); //腕足ヒット時のグラフィック
	if (IMAGE_MARK_R == NULL) return -1;
	IMAGE_AMMO = (SDL_Surface *) IMG_Load("image/ammo.bmp"); //弾数のグラフィック
	if (IMAGE_AMMO == NULL) return -1;
	IMAGE_WAIT = (SDL_Surface *) IMG_Load("image/wait.bmp"); //WAITのグラフィック
	if (IMAGE_WAIT == NULL) return -1;
	IMAGE_TITLE = (SDL_Surface *) IMG_Load("image/title.bmp"); //タイトルのグラフィック
	if (IMAGE_TITLE == NULL) return -1;
	IMAGE_START = (SDL_Surface *) IMG_Load("image/start.bmp"); //スタートボタンのグラフィック
	if (IMAGE_START == NULL) return -1;
	IMAGE_HELP = (SDL_Surface *) IMG_Load("image/help.bmp"); //ヘルプボタンのグラフィック
	if (IMAGE_HELP == NULL) return -1;
	IMAGE_END = (SDL_Surface *) IMG_Load("image/end.bmp"); //エンドボタンのグラフィック
	if (IMAGE_END == NULL) return -1;
	IMAGE_HELP_B = (SDL_Surface *) IMG_Load("image/help_b.bmp"); //ヘルプ解説のグラフィック
	if (IMAGE_HELP_B == NULL) return -1;
	IMAGE_BACK_S = (SDL_Surface *) IMG_Load("image/back_s.bmp"); //ヘルプの戻るのグラフィック
	if (IMAGE_BACK_S == NULL) return -1;
	IMAGE_PRINT = (SDL_Surface *) IMG_Load("image/print.bmp"); //ゲーム中のインターフェイスのグラフィック
	if (IMAGE_PRINT == NULL) return -1;
	IMAGE_CLEAR = (SDL_Surface *) IMG_Load("image/clear.bmp"); //リザルト画面のグラフィック
	if (IMAGE_CLEAR == NULL) return -1;
	IMAGE_ICON = (SDL_Surface *) IMG_Load("image/icon.bmp"); //アイコンのグラフィック
	if (IMAGE_ICON == NULL) return -1;
	IMAGE_NUMBER = (SDL_Surface *) IMG_Load("image/number.bmp"); //数字のグラフィック
	if (IMAGE_NUMBER == NULL) return -1;
	IMAGE_COLOR = (SDL_Surface *) IMG_Load("image/color.bmp"); //数字のグラフィック
	if (IMAGE_COLOR == NULL) return -1;

	//画像の透過設定
	for (i = 0; i < IMAGE_MAX; i++) {
		SDL_SetColorKey(image[i], SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(image[i]->format, 255, 0, 255));
	}


	SDL_WM_SetIcon(IMAGE_ICON, NULL); //アイコンの設定
	SDL_WM_SetCaption("HeadShot!!", "HeadShot!!"); 		//タイトルバーの設定
	SDL_ShowCursor(SDL_DISABLE); 			//マウスを非表示にする

	screen = SDL_SetVideoMode(VIDEO_W, VIDEO_H, VIDEO_BIT, SDL_SWSURFACE); //ウィンドウの設定
	if (screen == NULL) {
		return -1;
	}


	//mobの初期化
	for (i = 0; i < ENEMY_MAX; i++) {
		mob[i].pos.x = 0;
		mob[i].pos.y = 0;
		mob[i].pos.w = 0;
		mob[i].pos.h = 0;
		mob[i].hp = ENEMY_NONE;
		mob[i].animation = 0;
		mob[i].z = 0;
		mob[i].id = 0;
	}

	//effectの初期化
	for (i = 0; i < EFFECT_MAX; i++) {
		effect[i].pos.x = 0;
		effect[i].pos.y = 0;
		effect[i].pos.w = 0;
		effect[i].pos.h = 0;
		effect[i].id = EFFECT_NONE;
		effect[i].animation = 0;
	}

	time = TIMER_START;	//タイマー設定

	key_flg = 0;	//キーフラグ初期化

	while (flg == 0) { //ゲームループの開始
		
		fmt = screen -> format;
		rgb = SDL_MapRGB(fmt, 0xFF, 0x00, 0xFF);

		if (init >= 0) {
			if(init == SCENE_PLAY){		//SCENE_PLAY時の初期化
				//mobの初期化
				for (i = 0; i < ENEMY_MAX; i++) {
					mob[i].pos.x = 0;
					mob[i].pos.y = 0;
					mob[i].pos.w = 0;
					mob[i].pos.h = 0;
					mob[i].hp = ENEMY_NONE;
					mob[i].animation = 0;
					mob[i].z = 0;
					mob[i].id = 0;
				}
				//effectの初期化
				for (i = 0; i < EFFECT_MAX; i++) {
					effect[i].pos.x = 0;
					effect[i].pos.y = 0;
					effect[i].pos.w = 0;
					effect[i].pos.h = 0;
					effect[i].id = EFFECT_NONE;
					effect[i].animation = 0;
				}
				//タイマー設定
				time = TIMER_START;

				//弾
				ammo = AMMO_MAX;

				//スコア
				score = 0;

				//リロードタイマー
				reload_timer = 0;

				//各回数を初期化
				fire_count = 0;
				hit_count = 0;
				head_count = 0;
				body_count = 0;
				foot_count = 0;
				kill_count = 0;
			}
			scene = init;
			init = -1;
		}





		while (SDL_PollEvent(&event)) { //入力処理
			switch (event.type) {
				case SDL_KEYDOWN: //キーボードが押されたとき
					if(event.key.keysym.sym == ESC_KEY){
						flg = 1;
						break;
					}
					break;
				case SDL_MOUSEMOTION: //マウスが動かされたとき
					mouse_pos.x = event.motion.x; //マウスのX座標を保管する
					mouse_pos.y = event.motion.y; //マウスのY座標を保管する
					break;
				case SDL_MOUSEBUTTONDOWN: //マウスのボタンが押されたとき
					switch (event.button.button) {
				case SDL_BUTTON_LEFT: //左クリック
					if (scene == SCENE_PLAY) {
						if (ammo > 0 && reload_timer <= 0) { //弾があり、リロード時のウェイトが0の場合
							//弾発射処理
							for (i = ENEMY_MAX - 1; i > 0; i--) {	//手前から順番に	
								if (mob[i].hp != ENEMY_NONE) {	//敵が存在している
									if (mob[i].z <= 100 || mouse_pos.y <= 80) {	//敵の位置判定
										//アニメーションがニュートラル状態
										if (mob[i].animation / ENEMY_ANIMATION_SPEED == 1 || mob[i].animation / ENEMY_ANIMATION_SPEED == 3) {
											//頭にヒットした場合
											if (HITCHECK(12, 21, 4, 13) || HITCHECK(13, 20, 3, 14)) {
												color = Hit_Proc(&mob[i], &score, &head_count, HIT_HEAD, &kill_count);
												for (j = 0 ; j < EFFECT_MAX ; j++) {
													if (effect[j].id == EFFECT_NONE) {
														HitEffect(&effect[j], color, mouse_pos);
														break;
													}
												}
												break;
												//胴にヒットした場合
											} else if (HITCHECK(13, 20, 14, 23)){
												color = Hit_Proc(&mob[i], &score, &body_count, HIT_BODY, &kill_count);
												for (j = 0 ; j < EFFECT_MAX ; j++) {
													if (effect[j].id == EFFECT_NONE) {
														HitEffect(&effect[j], color, mouse_pos);
														break;
													}
												}
												break;
												//腕足にヒットした場合
											} else if (HITCHECK(10, 12, 19, 23) || HITCHECK(11, 13, 16, 19) || HITCHECK(12, 15, 26, 29) || HITCHECK(13, 15, 23, 26) || 
												HITCHECK(18, 20, 23, 26) || HITCHECK(18, 21, 26, 29) || HITCHECK(20, 22, 16, 19) || HITCHECK(21, 23, 19, 23)){
													color = Hit_Proc(&mob[i], &score, &foot_count, HIT_FOOT, &kill_count);
													for (j = 0 ; j < EFFECT_MAX ; j++) {
														if (effect[j].id == EFFECT_NONE) {
															HitEffect(&effect[j], color, mouse_pos);
															break;
														}
													}
													break;
											}
										//左手が前の状態
										} else if (mob[i].animation / ENEMY_ANIMATION_SPEED == 0) {
											//頭にヒットした場合
											if (HITCHECK(12, 21, 5, 14) || HITCHECK(13, 20, 4, 15)){
												color = Hit_Proc(&mob[i], &score, &head_count, HIT_HEAD, &kill_count);
												for (j = 0 ; j < EFFECT_MAX ; j++) {
													if (effect[j].id == EFFECT_NONE) {
														HitEffect(&effect[j], color, mouse_pos);
														break;
													}
												}
												break;
												//胴にヒットした場合
											} else if (HITCHECK(13, 20, 15, 26)) {
												color = Hit_Proc(&mob[i], &score, &body_count, HIT_BODY, &kill_count);
												for (j = 0 ; j < EFFECT_MAX ; j++) {
													if (effect[j].id == EFFECT_NONE) {
														HitEffect(&effect[j], color, mouse_pos);
														break;
													}
												}
												break;
												//腕足にヒットした場合
											} else if (HITCHECK( 9, 11, 17, 20) || HITCHECK(11, 13, 15, 18) || HITCHECK(12, 15, 28, 31) || HITCHECK(13, 16, 24, 25) ||
												HITCHECK(13, 15, 25, 28) || HITCHECK(18, 21, 24, 26) || HITCHECK(20, 22, 17, 20) || HITCHECK(21, 23, 20, 24)){
													color = Hit_Proc(&mob[i], &score, &foot_count, HIT_FOOT, &kill_count);
													for (j = 0 ; j < EFFECT_MAX ; j++) {
														if (effect[j].id == EFFECT_NONE) {
															HitEffect(&effect[j], color, mouse_pos);
															break;
														}
													}
													break;
											}
										//右手が前の状態
										} else if (mob[i].animation / ENEMY_ANIMATION_SPEED == 2) {
											//頭にヒットした場合
											if (HITCHECK(11, 20, 5, 14) || HITCHECK(12, 19, 4, 15)){
												color = Hit_Proc(&mob[i], &score, &head_count, HIT_HEAD, &kill_count);
												for (j = 0 ; j < EFFECT_MAX ; j++) {
													if (effect[j].id == EFFECT_NONE) {
														HitEffect(&effect[j], color, mouse_pos);
														break;
													}
												}
												break;
												//胴にヒットした場合
											} else if (HITCHECK(12, 19, 15, 24)) {
												color = Hit_Proc(&mob[i], &score, &body_count, HIT_BODY, &kill_count);
												for (j = 0 ; j < EFFECT_MAX ; j++) {
													if (effect[j].id == EFFECT_NONE) {
														HitEffect(&effect[j], color, mouse_pos);
														break;
													}
												}
												break;
												//腕足にヒットした場合
											} else if (HITCHECK( 9, 11, 20, 24) || HITCHECK(10, 12, 17, 20) || HITCHECK(11, 14, 24, 26) || HITCHECK(16, 19, 24, 25) ||
												HITCHECK(17, 19, 25, 28) || HITCHECK(17, 20, 28, 31) || HITCHECK(19, 21, 15, 18) || HITCHECK(21, 23, 17, 20)){
													color = Hit_Proc(&mob[i], &score, &foot_count, HIT_FOOT, &kill_count);
													for (j = 0 ; j < EFFECT_MAX ; j++) {
														if (effect[j].id == EFFECT_NONE) {
															HitEffect(&effect[j], color, mouse_pos);
															break;
														}
													}
													break;
											}
										}
									}
								}
							}
							//弾痕表示
							for (j = 0; j < EFFECT_MAX; j++) {
								if (effect[j].id == EFFECT_NONE) {
									GunEffect(&effect[j], mouse_pos);
									break;
								}
							}
							fire_count++;
							ammo--; //弾数を減らす
						}
						break;

					//タイトル時の処理
					} else if (scene == SCENE_TITLE) {
						if (BUTTON_CHECK(96, 80, 128, 48)) {
							init = SCENE_PLAY;		//ゲーム開始
						} else if (BUTTON_CHECK(96, 128, 128, 48)) {
							init = SCENE_HELP;		//ヘルプ画面へ
						} else if (BUTTON_CHECK(96, 176, 128, 48)) {
							flg = 1;					//終了処理
							break;
						//カーソルの色変更
						} else if (BUTTON_CHECK(248, 192, 16, 16)){
							cursorcolor = 0;
						} else if (BUTTON_CHECK(272, 192, 16, 16)){
							cursorcolor = 1;
						} else if (BUTTON_CHECK(296, 192, 16, 16)){
							cursorcolor = 2;
						} else if (BUTTON_CHECK(248, 216, 16, 16)){
							cursorcolor = 3;
						} else if (BUTTON_CHECK(272, 216, 16, 16)){
							cursorcolor = 4;
						} else if (BUTTON_CHECK(296, 216, 16, 16)){
							cursorcolor = 5;
						}
						//弾痕表示
						for (j = 0; j < EFFECT_MAX; j++) {
							if (effect[j].id == EFFECT_NONE) {
								GunEffect(&effect[j], mouse_pos);
								break;
							}
						}

					//ヘルプ時とクリアー時の処理
					} else if (scene == SCENE_HELP || scene == SCENE_CLEAR) {
						if (BUTTON_CHECK(288, 216, 32, 24)) {
							init = SCENE_TITLE;		//タイトル画面へ
						}
						//弾痕表示
						for (j = 0; j < EFFECT_MAX; j++) {
							if (effect[j].id == EFFECT_NONE) {
								GunEffect(&effect[j], mouse_pos);
								break;
							}
						}
					}
				case SDL_BUTTON_RIGHT: //右クリック
					if (ammo < AMMO_MAX) { //弾数がMAXじゃない場合
						ammo = AMMO_MAX; //弾数をMAXにする
						reload_timer = RELOAD_TIME; //リロード時のウェイト処理
					}
					break;
					}//end switch
					break;
				case SDL_QUIT: //終了した場合
					flg = 1; //終了フラグをONにする
					break;
			} //end switch
		} //キー入力ここまで


		//リロード時のウェイト処理
		if (reload_timer > 0) {
			if (--reload_timer <= 0) {
				reload_timer = 0;
			}
		}

		//敵移動処理
		for (i = 0; i < ENEMY_MAX; i++) {
			if (mob[i].hp >= -900) {
				if (--mob[i].z < 0) {
					mob[i].hp = ENEMY_NONE;
				}
				//位置毎に応じた移動処理
				if (mob[i].z <= 148 && mob[i].z > 132) {
					mob[i].y -= 1.0f;
				} else if (mob[i].z <= 132 && mob[i].z > 100) {
					mob[i].y -= 0.5f;
				} else if (mob[i].z <= 100 && mob[i].z > 68) {
					mob[i].y += 0.5f;
				} else if (mob[i].z <= 68 && mob[i].z > 36) {
					mob[i].y += 1.0f;
				} else if (mob[i].z <= 36 && mob[i].z > -10) {
					mob[i].y += 2.0f;
				}
				mob[i].pos.y = (Sint16)mob[i].y;
				//アニメーションの処理
				if (++mob[i].animation >= ENEMY_ANIMATION_SPEED * ENEMY_ANIMATION_PATTERN) {
					mob[i].animation = 0;
				}
			//透明化進行処理
			} else if (mob[i].hp < -900 && mob[i].hp != ENEMY_NONE) {
				mob[i].hp--;
			}
		}

		//エフェクト移動処理
		for (i = 0; i < EFFECT_MAX; i++) {
			if (effect[i].id != EFFECT_NONE) {
				if(effect[i].id / 4 == 0){
					if (--effect[i].animation < 0) { effect[i].id = EFFECT_NONE; }
				}else if(effect[i].id / 4 == 1){
					effect[i].pos.w += 1;
					effect[i].pos.y -= (effect[i].pos.w / 10);
					if (--effect[i].animation < 0) { effect[i].id = EFFECT_NONE; }
				}
			}
		}

		if (scene == SCENE_PLAY) {
			//敵出現処理
			if (rand() % 20 == 0) {
				for (i = 0; i < ENEMY_MAX; i++) {
					if (mob[i].hp == ENEMY_NONE) {
						mob[i].pos.x = rand() % 272 + 8;
						mob[i].pos.y = 80;
						mob[i].animation = 0;
						mob[i].z = 148.0f;
						mob[i].y = 80.0f;
						if (rand() % 5 == 0) {			//赤色
							mob[i].hp = ENEMY_HP * 2;
							mob[i].id = ENEMY_RED;
						} else if (rand() % 10 == 0) {	//緑色
							mob[i].hp = ENEMY_HP;
							mob[i].id = ENEMY_GREEN;
						} else if (rand() % 20 == 0) {	//紫色
							mob[i].hp = 1;
							mob[i].id = ENEMY_PURPLE;
						} else {							//青色
							mob[i].hp = ENEMY_HP;
							mob[i].id = ENEMY_BLUE;
						}
						break;
					}
				}
			}


			//タイマー減少
			if (--time <= 0) {
				init = SCENE_CLEAR;
			}



			//ソート処理
			for (i = 0; i < ENEMY_MAX - 1; i++) {
				for (j = i + 1; j < ENEMY_MAX; j++) {
					if (mob[i].z < mob[j].z) {
						change = mob[i];
						mob[i] = mob[j];
						mob[j] = change;
					}
				}
			}

		}

		SDL_FillRect(screen, NULL, rgb);

		//背景描画最奥
		SetImagePos(*IMAGE_BACK, *screen, 0, 0, 0, 0, 320, 240);

		//敵描画奥側
		for (i = 0; i < ENEMY_MAX; i++) {
			if (mob[i].hp != ENEMY_NONE) {
				if (mob[i].z < 100) {
					break;
				}
				if (mob[i].hp <= ENEMY_DEAD) {
					SDL_SetAlpha(IMAGE_ENEMY, SDL_SRCALPHA, (255 - ((-999) - mob[i].hp) * 4 - 1));
				}
				SetImagePos(*IMAGE_ENEMY, *screen, mob[i].pos.x, mob[i].pos.y, (mob[i].animation / ENEMY_ANIMATION_SPEED) * IMAGE_ENEMY_W, 
					mob[i].id * IMAGE_ENEMY_H, IMAGE_ENEMY_W, IMAGE_ENEMY_H);
				SDL_SetAlpha(IMAGE_ENEMY, SDL_SRCALPHA, 255);
			}
		}

		//背景描画
		SetImagePos(*IMAGE_BACK, *screen, 0, 80, 0, 80, 320, 64);

		//敵描画手前側
		for (; i < ENEMY_MAX; i++) {
			if (mob[i].hp != ENEMY_NONE) {
				if (mob[i].hp <= ENEMY_DEAD) {
					//敵の透明度設定
					SDL_SetAlpha(IMAGE_ENEMY, SDL_SRCALPHA, (255 - (ENEMY_NONE - mob[i].hp) * 4 - 1));
				}
				SetImagePos(*IMAGE_ENEMY, *screen, mob[i].pos.x, mob[i].pos.y, (mob[i].animation / ENEMY_ANIMATION_SPEED) * IMAGE_ENEMY_W, 
					mob[i].id * IMAGE_ENEMY_H, IMAGE_ENEMY_W, IMAGE_ENEMY_H);
				SDL_SetAlpha(IMAGE_ENEMY, SDL_SRCALPHA, 255);
			}
		}

		//背景描画手前
		SetImagePos(*IMAGE_BACK, *screen, 0, 168, 0, 168, 320, 32);	

		//タイトル画面の時
		if (scene == SCENE_TITLE) {
			SetImagePos(*IMAGE_TITLE, *screen, 0, 0, 0, 0, 320, 80);	//タイトル文字描画
			src.y = 0;
			if (BUTTON_CHECK(96, 80, 128, 48)){
				src.y += 48;
			}
			SetImagePos(*IMAGE_START, *screen, 96, 80, 0, src.y, 128, 48);	//スタート文字描画

			src.y = 0;
			if(BUTTON_CHECK(96, 128, 128, 48)){
				src.y += 48;
			}
			SetImagePos(*IMAGE_HELP, *screen, 96, 128, 0, src.y, 128, 48);	//ヘルプ文字描画

			src.y = 0;
			if(BUTTON_CHECK(96, 176, 128, 48)){
				src.y += 48;
			}
			SetImagePos(*IMAGE_END, *screen, 96, 176, 0, src.y, 128, 48);	//エンド文字描画

			for(i = 0 ; i < COLOR_MAX ; i++){
				SetImagePos(*IMAGE_COLOR, *screen, 248 + (i % 3) * 24, 192 + (i / 3) * 24, (i % 3) * 16, (i / 3) * 16, 16, 16);
			}

		//ヘルプ画面の時
		} else if (scene == SCENE_HELP) {

			SetImagePos(*IMAGE_HELP_B, *screen, 0, 0, 0, 0, 320, 240);

			src.y = 0;
			if(BUTTON_CHECK(288, 216, 32, 24)){
				src.y += 24;
			}
			SetImagePos(*IMAGE_BACK_S, *screen, 288, 216, 0, src.y, 32, 24);

		//クリアー画面の時
		} else if (scene == SCENE_CLEAR) {

			//クリアー描画
			SetImagePos(*IMAGE_CLEAR, *screen, 0, 0, 0, 0, 320, 240);

			numberflg = 0;
			c_score = score;

			//スコア表示
			i = 1000000;
			if (c_score == 0) {
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (6 * 16), 54, 0, 0, 16, 32);

			} else {
				for (i = 1000000, j = 0 ; i > 10 ; i /= 10, j++) {
					if ((int) (c_score / i) > 0) {
						numberflg = 1;
					}
					if ((int) c_score / i != 0 || numberflg == 1) {
						SetImagePos(*IMAGE_NUMBER, *screen, 200 + (j * 16), 54, (int)(c_score / i) * 16, 0, 16, 32);
					}
					c_score %= i;
				}
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (6 * 16), 54, 0, 0, 16, 32);
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (5 * 16), 54, 0, 0, 16, 32);
			}
			//ヒット率表示
			hit = (float)(head_count + body_count + foot_count) / fire_count * 100;
			c_score = (int)hit;
			if(c_score == 0){
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (4 * 16), 86, 0, 0, 16, 32);
			} else if(c_score == 100){
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (2 * 16), 86, 16, 0, 16, 32);
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (3 * 16), 86,  0, 0, 16, 32);
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (4 * 16), 86,  0, 0, 16, 32);
			} else {
				if((int)c_score / 10 != 0){
					SetImagePos(*IMAGE_NUMBER, *screen, 200 + (3 * 16), 86, (int)(c_score / 10) * 16, 0, 16, 32);
				}
				c_score %= 10;
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (4* 16), 86, c_score * 16, 0, 16, 32);
			}

			//kill数表示
			if(kill_count >= 10000){ kill_count = 9999; }
			c_score = kill_count;
			numberflg = 0;
			if(c_score == 0){
				SetImagePos(*IMAGE_NUMBER, *screen, 248 + (3 * 16), 120, 0, 0, 16, 32);
			}else{
				for (i = 1000, j = 0 ; i >= 1 ; i /= 10, j++) {
					if ((int) (c_score / i) > 0) {
						numberflg = 1;
					}
					if ((int) c_score / i != 0 || numberflg == 1) {
						SetImagePos(*IMAGE_NUMBER, *screen, 248 + (j * 16), 120, (int)(c_score / i) * 16, 0, 16, 32);
					}
					c_score %= i;
				}
			}

			//頭を撃った回数表示
			if(head_count >= 1000){ head_count = 999; }
			c_score = head_count;
			numberflg = 0;
			if(c_score == 0){
				SetImagePos(*IMAGE_NUMBER, *screen, 48 + (2 * 16), 152, 0, 0, 16, 32);
			}else{
				for (i = 100, j = 0 ; i >= 1 ; i /= 10, j++) {
					if ((int) (c_score / i) > 0) {
						numberflg = 1;
					}
					if ((int) c_score / i != 0 || numberflg == 1) {
						SetImagePos(*IMAGE_NUMBER, *screen, 48 + (j * 16), 152, (int)(c_score / i) * 16, 0, 16, 32);
					}
					c_score %= i;
				}
			}
			
			//体を撃った回数表示
			if(body_count >= 1000){ body_count = 999; }
			c_score = body_count;
			numberflg = 0;
			if(c_score == 0){
				SetImagePos(*IMAGE_NUMBER, *screen, 144 + (2 * 16), 152, 0, 0, 16, 32);
			}else{
				for (i = 100, j = 0 ; i >= 1 ; i /= 10, j++) {
					if ((int) (c_score / i) > 0) {
						numberflg = 1;
					}
					if ((int) c_score / i != 0 || numberflg == 1) {
						SetImagePos(*IMAGE_NUMBER, *screen, 144 + (j * 16), 152, (int)(c_score / i) * 16, 0, 16, 32);
					}
					c_score %= i;
				}
			}
			
			//足を撃った回数表示
			if(foot_count >= 1000){ foot_count = 999; }
			c_score = foot_count;
			numberflg = 0;
			if(c_score == 0){
				SetImagePos(*IMAGE_NUMBER, *screen, 240 + (2 * 16), 152, 0, 0, 16, 32);
			}else{
				for (i = 100, j = 0 ; i >= 1 ; i /= 10, j++) {
					if ((int) (c_score / i) > 0) {
						numberflg = 1;
					}
					if ((int) c_score / i != 0 || numberflg == 1) {
						SetImagePos(*IMAGE_NUMBER, *screen, 240 + (j * 16), 152, (int)(c_score / i) * 16, 0, 16, 32);
					}
					c_score %= i;
				}
			}

			//戻るボタン表示
			src.y = 0;
			if (BUTTON_CHECK(288, 216, 32, 24)){
				src.y += 24;
			}
			SetImagePos(*IMAGE_BACK_S, *screen, 288, 216, 0, src.y, 32, 24);
		}

		//プレイ時
		if (scene == SCENE_PLAY) {
			//残り弾数描画
			for (i = 0; i < ammo; i++) {
				SetImagePos(*IMAGE_AMMO, *screen, 9 + ((i % 16) * (IMAGE_AMMO_W + 1)), 200 + ((i / 16) * IMAGE_AMMO_H), 0, 0, IMAGE_AMMO_W, IMAGE_AMMO_H);
			}
			if (reload_timer > 0) {
				SetImagePos(*IMAGE_WAIT, *screen, 16, 208, 0,  0,                64, 16);
				SetImagePos(*IMAGE_WAIT, *screen, 16, 208, 0, 16, 64 - reload_timer, 16);
			}

			SetImagePos(*IMAGE_PRINT, *screen, 168, 216, 0, 16, 32, 16);
			SetImagePos(*IMAGE_PRINT, *screen,  96, 216, 0,  0, 32, 16);

			//スコア表示
			if (score > 9999999) {
				score = 9999900;
			}
			numberflg = 0;
			c_score = score;
			i = 1000000;
			if (c_score == 0) {
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (6 * 16), 200, 0, 0, 16, 32);
			} else {
				for (i = 1000000, j = 0; i > 10; i /= 10, j++) {
					if ((int) (c_score / i) > 0) {
						numberflg = 1;
					}
					if ((int) c_score / i != 0 || numberflg == 1) {
						SetImagePos(*IMAGE_NUMBER, *screen, 200 + (j * 16), 200, (int)(c_score / i) * 16, 0, 16, 32);
					}
					c_score %= i;
				}
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (6 * 16), 200, 0, 0, 16, 32);
				SetImagePos(*IMAGE_NUMBER, *screen, 200 + (5 * 16), 200, 0, 0, 16, 32);

			}

			c_time = time;

			//タイム表示
			//10
			SetImagePos(*IMAGE_NUMBER, *screen, 128, 200, (int)(c_time / 600) * 16, 0, 16, 32);
			c_time %= 600;
			SetImagePos(*IMAGE_NUMBER, *screen, 144, 200, (int)(c_time /  60) * 16, 0, 16, 32);
		}

		//エフェクト描画
		for (j = 0; j < EFFECT_MAX; j++) {
			if (effect[j].id != EFFECT_NONE) {
				if(effect[j].id / 4 == 0){
					SDL_SetAlpha(IMAGE_HIT, SDL_SRCALPHA, effect[j].animation * 4);
					SetImagePos(*IMAGE_HIT, *screen, effect[j].pos.x - 4, effect[j].pos.y - 4, effect[j].id & 2 * 8, effect[j].id / 2 * 8, 8, 8);
					SDL_SetAlpha(IMAGE_HIT, SDL_SRCALPHA, 255);
				}else if(effect[j].id / 4 >= 1){
					SDL_SetAlpha(image[effect[j].id], SDL_SRCALPHA, effect[j].animation * 4);
					SetImagePos(*image[effect[j].id], *screen, effect[j].pos.x, effect[j].pos.y, 0, 0, 32, 16);
					SDL_SetAlpha(image[effect[j].id], SDL_SRCALPHA, 255);
				}
			}
		}

		//照準の表示
		if(ammo == 0){
			SetImagePos(*IMAGE_AIM, *screen, mouse_pos.x - 15, mouse_pos.y - 15, 6 * 32, 0, 32, 32);
		} else {
			SetImagePos(*IMAGE_AIM, *screen, mouse_pos.x - 15, mouse_pos.y - 15, cursorcolor * 32, 0, 32, 32);
		}

		SDL_Flip(screen);


		fps_wait();


	} //ゲームループ終了

	SDL_FreeSurface(screen);
	for (i = 0; i < IMAGE_MAX; i++) {
		SDL_FreeSurface(image[i]);
	}

	printf("OFF¥n");
	SDL_Quit();
	return 0;
}

void fps_wait(void) {
	unsigned int now_time, left_time;
	static unsigned int last_time = 0;

	now_time = SDL_GetTicks();

	left_time = last_time + INTERVAL - now_time;
	if (last_time + INTERVAL > now_time) {
		SDL_Delay(left_time);
		last_time = now_time + left_time;
	} else {
		last_time = now_time;
	}
	return;
}


//弾が敵ヒットしたとき用の関数
int Hit_Proc(struct MOB_DATA *mob, int *score, int *count, int hitplace, int *kill_count){
	int n = -1;
	int scoreplus = 0;
	int hitp = hitplace;
	if (mob->id == ENEMY_GREEN && hitp != HIT_BODY) { hitp = 4 - hitp; }
	if((mob->hp -= hitp * 2) <= 0){
		mob->hp = ENEMY_DEAD;
		mob->animation = ENEMY_ANIMATION_DEAD;
		*kill_count += 1;
	}
	scoreplus = (hitp == HIT_HEAD ? 500 : hitp * 100);
	if(mob->id == ENEMY_PURPLE){ scoreplus *= 2; }
	n = 7 - hitp;
	*score += scoreplus;
	*count += 1;
	return n;
}

//ヒット時のエフェクト表示用関数
int HitEffect(struct EFFECT_DATA *effect, int color, SDL_Rect mouse_pos){
	if(effect->id != EFFECT_NONE){
		return 0;
	}
	effect->id = color;
	effect->pos.x = mouse_pos.x + 3;
	effect->pos.y = mouse_pos.y - 32;
	effect->pos.w = 0;
	effect->animation = 64;
	return 1;
}

//銃を撃った時のエフェクト表示用関数
void GunEffect(struct EFFECT_DATA *effect, SDL_Rect mouse_pos){
	effect->id = rand() % 4;
	effect->pos.x = mouse_pos.x + rand() % 2;
	effect->pos.y = mouse_pos.y + rand() % 2;
	effect->animation = 64;
	effect->pos.w = 0;
	return;
}

//イメージ描画用関数
void SetImagePos(SDL_Surface image, SDL_Surface screen, Sint16 dx, Sint16 dy, Sint16 sx, Sint16 sy, Uint16 sw, Uint16 sh){
	SDL_Rect dsr, src;
	dsr.x = dx;
	dsr.y = dy;
	src.x = sx;
	src.y = sy;
	src.w = sw;
	src.h = sh;
	SDL_BlitSurface(&image, &src, &screen, &dsr);
	return;
}

